<?xml version="1.0" encoding="UTF-8"?>
<!-- Copyright (C) 2012 Oleh Radvanskyj -->
<xsl:stylesheet version="2.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:xs="http://www.w3.org/2001/XMLSchema" xmlns:fn="http://www.w3.org/2005/xpath-functions">
    <xsl:output method="html" encoding="UTF-8" />

    <!-- types -->

    <xsl:template match="model | implementation | solution | package | realization | capsule" mode="table_of_contents_types">
        <xsl:if test="types">
            <li><a href="#{generate-id(types)}-header" onclick="expandAncestors('{generate-id(types)}-header')">Types</a></li>
        </xsl:if>
    </xsl:template>

    <xsl:template match="model/types | implementation/types | solution/types">
        <h3 id="{generate-id(.)}-header" onclick="toggleTag('{generate-id(.)}')">Types</h3>
        <ul id="{generate-id(.)}" class="attributes">
            <xsl:apply-templates />
        </ul>
    </xsl:template>

    <xsl:template match="package/types | realization/types | capsule/types">
        <h4 id="{generate-id(.)}-header" onclick="toggleTag('{generate-id(.)}')">Types</h4>
        <ul id="{generate-id(.)}" class="attributes">
            <xsl:apply-templates />
        </ul>
    </xsl:template>

</xsl:stylesheet>