<?xml version="1.0" encoding="UTF-8"?>
<!-- Copyright (C) 2013 Oleh Radvanskyj -->
<xsl:stylesheet version="2.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:xs="http://www.w3.org/2001/XMLSchema" xmlns:fn="http://www.w3.org/2005/xpath-functions">
  <xsl:output method="html" encoding="UTF-8" indent="yes"/>
  
  <!-- specification -->
  
  <xsl:template match="domain | package | use-case | segment" mode="table_of_contents_specification">
	<xsl:if test="specification">
		<li><a href="#{generate-id(specification)}-header" onclick="expandAncestors('{generate-id(specification)}-header')">Specification</a></li>
	</xsl:if>
  </xsl:template>

    <xsl:template match="domain/specification">
        <h2 id="{generate-id(.)}-header" onclick="toggleSpecification('{generate-id(.)}')">Specification</h2>
        <ol id="{generate-id(.)}" state="hidden" class="specification" style="display:none">
            <xsl:apply-templates />
        </ol>
    </xsl:template>

	<xsl:template match="package/specification | use-case/specification | segment/specification">
		<h3 id="{generate-id(.)}-header" onclick="toggleSpecification('{generate-id(.)}')">Specification</h3>
		<ol id="{generate-id(.)}" state="hidden" class="specification" style="display:none">
			<xsl:apply-templates />
		</ol>
	</xsl:template>

    <xsl:template match="actor/specification | worker/specification | worker-feature/specification | entity/specification | entity-feature/specification">
        <h3 onclick="toggleSpecification('{generate-id(.)}')">Specification</h3>
        <ol id="{generate-id(.)}" state="hidden" class="specification" style="display:none">
            <xsl:apply-templates />
        </ol>
    </xsl:template>

</xsl:stylesheet>