<?xml version="1.0" encoding="UTF-8"?>
<!-- Copyright (C) 2013 Oleh Radvanskyj -->
<xsl:stylesheet version="2.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:xs="http://www.w3.org/2001/XMLSchema" xmlns:fn="http://www.w3.org/2005/xpath-functions">
	<xsl:output method="html" encoding="UTF-8" indent="yes"/>
	
  <!-- overview -->
  
  <!-- model -->
  
  <xsl:template match="model" mode="table_of_contents_overview">
	<xsl:if test="packages or classes or capsules or functions or threads or actors or use-case or test-procedures">
		<li><a href="#overview"  onclick="expandAncestors('overview')">Overview</a></li>
	</xsl:if>
  </xsl:template>
  
  <xsl:template match="model" mode="overview">
	<xsl:if test="packages or classes or capsules or functions or threads or actors or use-case or test-procedures">
		<h3 id="overview" onclick="toggleTag('{generate-id(.)}-overview')">Overview</h3>
		<div id="{generate-id(.)}-overview" class="indent" style="display:none">
			<xsl:apply-templates select="." mode="overview_content" />
		</div>
  	</xsl:if>
  </xsl:template>
  
  <!-- package -->
  
  <xsl:template match="package" mode="table_of_contents_overview">
	<xsl:if test="packages or classes or capsules or functions or threads or actors or use-case or test-procedures">
		<li><a href="#{generate-id(.)}-overview-header"  onclick="expandAncestors('{generate-id(.)}-overview-header')">Overview</a></li>
	</xsl:if>
  </xsl:template>
  
  <xsl:template match="package" mode="overview">
	<xsl:if test="packages or classes or capsules or functions or threads or actors or use-case or test-procedures">
		<h4 id="{generate-id(.)}-overview-header" onclick="toggleTag('{generate-id(.)}-overview')">Overview</h4>
		<div id="{generate-id(.)}-overview" class="indent" style="display:none">
			<xsl:apply-templates select="." mode="overview_content" />
		</div>
  	</xsl:if>
  </xsl:template>

  <!-- use case -->

    <xsl:template match="use-case | segment" mode="table_of_contents_overview">
        <xsl:if test="packages or use-case">
            <li><a href="#{generate-id(.)}-overview-header"  onclick="expandAncestors('{generate-id(.)}-overview-header')">Overview</a></li>
        </xsl:if>
    </xsl:template>

    <xsl:template match="model/use-case" mode="overview">
        <xsl:if test="packages or use-case">
            <h3 id="{generate-id(.)}-overview-header" onclick="toggleTag('{generate-id(.)}-overview')">Overview</h3>
            <div id="{generate-id(.)}-overview" class="indent" style="display:none">
                <xsl:apply-templates select="." mode="overview_content" />
            </div>
        </xsl:if>
    </xsl:template>

    <xsl:template match="package/use-case | use-case/use-case | segment | segment/use-case" mode="overview">
        <xsl:if test="packages or use-case">
            <h4 id="{generate-id(.)}-overview-header" onclick="toggleTag('{generate-id(.)}-overview')">Overview</h4>
            <div id="{generate-id(.)}-overview" class="indent" style="display:none">
                <xsl:apply-templates select="." mode="overview_content" />
            </div>
        </xsl:if>
    </xsl:template>

    <!-- realization -->

    <xsl:template match="realization" mode="table_of_contents_overview">
        <xsl:if test="classes or functions or threads or capsules or test-procedures">
            <li><a href="#{generate-id(.)}-overview-header"  onclick="expandAncestors('{generate-id(.)}-overview-header')">Overview</a></li>
        </xsl:if>
    </xsl:template>

    <xsl:template match="realization" mode="overview">
        <xsl:if test="classes or functions or threads or capsules or test-procedures">
            <h4 id="{generate-id(.)}-overview-header" onclick="toggleTag('{generate-id(.)}-overview')">Overview</h4>
            <div id="{generate-id(.)}-overview" class="indent" style="display:none">
                <xsl:apply-templates select="." mode="overview_content" />
            </div>
        </xsl:if>
    </xsl:template>

    <!-- common -->
  
    <xsl:template match="model | package" mode="overview_content">
        <xsl:apply-templates select="." mode="overview_packages" />
        <xsl:apply-templates select="." mode="overview_capsules" />
        <xsl:apply-templates select="." mode="overview_classes" />
        <xsl:apply-templates select="." mode="overview_functions" />
        <xsl:apply-templates select="." mode="overview_threads" />
        <xsl:apply-templates select="." mode="overview_actors" />
        <xsl:apply-templates select="." mode="overview_use_cases" />
        <xsl:apply-templates select="." mode="overview_test_procedures" />
    </xsl:template>
  
    <xsl:template match="use-case | segment" mode="overview_content">
        <xsl:apply-templates select="." mode="overview_packages" />
        <xsl:apply-templates select="." mode="overview_use_cases" />
    </xsl:template>

    <xsl:template match="realization" mode="overview_content">
        <xsl:apply-templates select="." mode="overview_capsules" />
        <xsl:apply-templates select="." mode="overview_classes" />
        <xsl:apply-templates select="." mode="overview_functions" />
        <xsl:apply-templates select="." mode="overview_threads" />
        <xsl:apply-templates select="." mode="overview_test_procedures" />
    </xsl:template>

</xsl:stylesheet>